2007-05-24 10:00 Christos Zoulas <christos@zoulas.com>

	* Fix another integer overflow (Colin Percival)

2007-03-26 13:58 Christos Zoulas <christos@zoulas.com>

	* make sure that all of struct magic_set is initialized appropriately
	  (Brett)

2007-03-25 17:44 Christos Zoulas <christos@zoulas.com>

	* reset left bytes in the buffer (Dmitry V. Levin)

	* compilation failed with COMPILE_ONLY and ENABLE_CONDITIONALS
	  (Peter Avalos)

2007-03-15 10:51 Christos Zoulas <christos@zoulas.com>

	* fix fortran and nroff reversed tests (Dmitry V. Levin)
	
	* fix exclude option (Dmitry V. Levin)

2007-02-08 17:30 Christos Zoulas <christos@zoulas.com>

	* fix integer underflow in file_printf which can lead to
	  to exploitable heap overflow (Jean-Sebastien Guay-Lero)

2007-02-05 11:35 Christos Zoulas <christos@zoulas.com>

	* make socket/pipe reading more robust

2007-01-25 16:01 Christos Zoulas <christos@zoulas.com>

	* Centralize all the tests in file_buffer.

	* Add exclude flag.

2007-01-18 05:29 Anon Ymous <do@not.spam.me>
	
	* Move the "type" detection code from parse() into its own table
	  driven routine.  This avoids maintaining multiple lists in
	  file.h.

	* Add an optional conditional field (ust before the type field).
	  This code is wrapped in "#ifdef ENABLE_CONDITIONALS" as it is
	  likely to go away.
	
2007-01-16 23:24 Anon Ymous <do@not.spam.me>

	* Fix an initialization bug in check_mem().

2007-01-16 14:58 Anon Ymous <do@not.spam.me>

	* Add a "default" type to print a message if nothing previously
	  matched at that level or since the last default at that
	  level.  This is useful for setting up switch-like statements.
	  It can also be used to do if/else constructions without a
	  redundant second test.

	* Fix the "x" special case test so that one can test for that
	  string with "=x".

	* Allow "search" to search the entire buffer if the "/N"
	  search count is missing.

	* Make "regex" work!  It now starts its search at the
	  specified offset and takes an (optional) "/N" line count to
	  specify the search range; otherwise it searches to the end
	  of the file.  The match is now grabbed correctly for format
	  strings and the offset set to the end of the match.

	* Add a "/s" flag to "regex" and "search" to set the offset to
	  the start of the match.  By default the offset is set to the
	  end of the match, as it is with other tests.  This is mostly
	  useful for "regex".

	* Make "search", "string" and "pstring" use the same
	  file_strncmp() routine so that they support the same flags;
	  "bestring16" and "lestring16" call the same routine, but
	  with flags = 0.  Also add a "/C" flag (in analogy to "/c")
	  to ignore the case on uppercase (lowercase) characters in
	  the test string.

	* Strict adherence to C style string escapes.  A warnings are
	  printed when compiling.  Note: previously "\a" was
	  incorrectly translated to 'a' instead of an <alert> (i.e.,
	  BELL, typically 0x07).

	* Make this compile with "-Wall -Wextra" and all the warning
	  flags used with WARNS=4 in the NetBSD source.  Also make it
	  pass lint.

	* Many "cleanups" and hopefully not too many new bugs!

2007-01-16 14:56 Anon Ymous <do@not.spam.me>

	* make several more files compile with gcc warnings
	  on and also make them pass lint.

2007-01-16 14:54 Anon Ymous <do@not.spam.me>

	* fix a puts()/putc() usage goof in file.c

	* make file.c compile with gcc warnings and pass lint

2006-12-11 16:49 Christos Zoulas <christos@zoulas.com>

	* fix byteswapping issue

	* report the number of bytes we tried to
	  allocate when allocation fails

	* add a few missed cases in the strength routine

2006-12-08 16:32 Christos Zoulas <christos@zoulas.com>

	* store and print the line number of the magic
	  entry for debugging.         

	* if the magic entry did not print anything,
	  don't treat it as a match

	* change the magic strength algorithm to take
	  into account the relationship op.

	* fix a bug in search where we could accidentally
	  return a match.

	* propagate the error return from match to
	  file_softmagic.

2006-11-25 13:35 Christos Zoulas <christos@zoulas.com>
	
	* Don't store the current offset in the magic
	  struct, because it needs to be restored and
	  it was not done properly all the time. Bug
	  found by: Arkadiusz Miskiewicz

	* Fix problem in the '\0' separator; and don't
	  print it as an additional separator; print
	  it as the only separator.

2006-11-17 10:51 Christos Zoulas <christos@zoulas.com>

	* Added a -0 option to print a '\0' separator
	  Etienne Buira <etienne.buira@free.fr>

2006-10-31 15:14 Christos Zoulas <christos@zoulas.com>

	* Check offset before copying (Mike Frysinger)

	* merge duplicated code

	* add quad date support

	* make sure that we nul terminate desc (Ryoji Kanai)

	* don't process elf notes multiple times

	* allow -z to report empty compressed files

	* use calloc to initialize the ascii buffers (Jos van den Oever)

2006-06-08 11:11 Christos Zoulas <christos@zoulas.com>

	* QNX fixes (Mike Gorchak)

	* Add quad support.

	* FIFO checks (Dr. Werner Fink)

	* Linux ELF fixes (Dr. Werner Fink)

	* Magic format checks (Dr. Werner Fink)

	* Magic format function improvent (Karl Chen)

2006-05-03 11:11 Christos Zoulas <christos@zoulas.com>

	* Pick up some elf changes and some constant fixes from SUSE

	* Identify gnu tar vs. posix tar

	* When keep going, don't print spurious newlines (Radek Vokál)

2006-04-01 12:02 Christos Zoulas <christos@zoulas.com>

	* Use calloc instead of malloc (Mike Frysinger)

	* Fix configure script to detect wctypes.h (Mike Frysinger)

2006-03-02 16:06 Christos Zoulas <christos@zoulas.com>

	* Print empty if the file is (Mike Frysinger)

	* Don't try to read past the end of the buffer (Mike Frysinger)

	* Sort magic entries by strength [experimental]

2005-11-29 13:26 Christos Zoulas <christos@zoulas.com>

	* Use iswprint() to convert the output string.
	    (Bastien Nocera)

2005-10-31 8:54 Christos Zoulas <christos@zoulas.com>

	* Fix regression where the core info was not completely processed
	    (Radek Vokál)

2005-10-20 11:15 Christos Zoulas <christos@zoulas.com>

	* Middle Endian magic (Diomidis Spinellis)

2005-10-17 11:15 Christos Zoulas <christos@zoulas.com>

	* Open with O_BINARY for CYGWIN (Corinna Vinschen)

	* Don't close stdin (Arkadiusz Miskiewicz)

	* Look for note sections in non executables.

2005-09-20 13:33 Christos Zoulas <christos@zoulas.com>
	
	* Don't print SVR4 Style in core files multiple times
	    (Radek Vokál)

2005-08-27 04:09 Christos Zoulas <christos@zoulas.com>

	* Cygwin changes Corinna Vinschen

2005-08-18 09:53 Christos Zoulas <christos@zoulas.com>

	* Remove erroreous mention of /etc/magic in the file man page
	  This is gentoo bug 101639. (Mike Frysinger) 

	* Cross-compile support and detection (Mike Frysinger) 

2005-08-12 10:17 Christos Zoulas <christos@zoulas.com>

	* Add -h flag and dereference symlinks if POSIXLY_CORRECT
	  is set.

2005-07-29 13:57 Christos Zoulas <christos@zoulas.com>

	* Avoid search and regex buffer overflows (Kelledin)

2005-07-12 11:48 Christos Zoulas <christos@zoulas.com>

	* Provide stub implementations for {v,}nsprintf() for older
	  OS's that don't have them.
	* Change mbstate_t autoconf detection macro from AC_MBSTATE_T
	  to AC_TYPE_MBSTATE_T.

2005-06-25 11:48 Christos Zoulas <christos@zoulas.com>

	* Dynamically allocate the string buffers and make the
	  default read size 256K.

2005-06-01 00:00 Joerg Sonnenberger <joerg@britannica.bec.de>

	* Dragonfly ELF note support

2005-03-14 00:00 Giuliano Bertoletti <gb@symbolic.it>

	* Avoid NULL pointer dereference in time conversion.

2005-03-06 00:00  Joerg Walter <jwalt@mail.garni.ch>
	
	* Add indirect magic offset support, and search mode.

2005-01-12 00:00  Stepan Kasal  <kasal@ucw.cz>

        * src/ascmagic.c (file_ascmagic): Fix three bugs about text files:
          If a CRLF text file happens to have CR at offset HOWMANY - 1
          (currently 0xffff), it should not be counted as CR line
          terminator.
          If a line has length exactly MAXLINELEN, it should not yet be
          treated as a ``very long line'', as MAXLINELEN is ``longest sane
          line length''.
          With CRLF, the line length was not computed correctly, and even
          lines of length MAXLINELEN - 1 were treated as ``very long''.

2004-12-07 14:15  Christos Zoulas  <christos@zoulas.com>

	* bzip2 needs a lot of input buffer space on some files
	  before it can begin uncompressing. This makes file -z
	  fail on some bz2 files. Fix it by giving it a copy of
	  the file descriptor to read as much as it wants if we
	  have access to it. <christos@zoulas.com>

2004-11-24 12:39  Christos Zoulas  <christos@zoulas.com>

	* Stack smash fix, and ELF more conservative reading.
	  Jakub Bogusz <qboosh@pld-linux.org>

2004-11-20 18:50  Christos Zoulas  <christos@zoulas.com>

	* New FreeBSD version parsing code:
	  Jon Noack <noackjr@alumni.rice.edu>

	* Hackish support for ucs16 strings <christos@zoulas.com>

2004-11-13 03:07  Christos Zoulas  <christos@zoulas.com>

	* print the file name and line number in syntax errors.

2004 10-12 10:50  Christos Zoulas  <christos@zoulas.com>

	* Fix stack overwriting on 0 length strings: Tim Waugh
	    <twaugh@redhat.com> Ned Ludd <solar@gentoo.org>

2004-09-27 11:30  Christos Zoulas  <christos@zoulas.com>

	* Remove 3rd and 4th copyright clause; approved by Ian Darwin.

	* Fix small memory leaks; caught by: Tamas Sarlos 
	    <stamas@csillag.ilab.sztaki.hu>

2004-07-24 16:33  Christos Zoulas  <christos@zoulas.com>

	* magic.mime update Danny Milosavljevic <danny.milo@gmx.net> 

	* FreeBSD version update Oliver Eikemeier <eikemeier@fillmore-labs.com>

	* utime/utimes detection Ian Lance Taylor <ian@wasabisystems.com>

  	* errors reading elf magic Jakub Bogusz <qboosh@pld-linux.org>

2004-04-12 10:55  Christos Zoulas  <christos@zoulas.com>

	* make sure that magic formats match magic types during compilation

	* fix broken sgi magic file

2004-04-06 20:36  Christos Zoulas  <christos@zoulas.com>

	* detect present of mbstate_t Petter Reinholdtsen <pere@hungry.com>

	* magic fixes

2004-03-22 15:25  Christos Zoulas  <christos@zoulas.com>

	* Lots of mime fixes
	  (Joerg Ostertag) <ostertag@rechengilde.de>

	* FreeBSD ELF version handling
	  (Edwin Groothuis) <edwin@mavetju.org>

	* correct cleanup in all cases; don't just close the file.
	  (Christos Zoulas) <christos@zoulas.com>

	* add gettext message catalogue support
	  (Michael Piefel) <piefel@debian.org>

	* better printout for unreadable files
	  (Michael Piefel) <piefel@debian.org>

	* compensate for missing MAXPATHLEN
	  (Michael Piefel) <piefel@debian.org>

	* add wide character string length computation
	  (Michael Piefel) <piefel@debian.org>

	* Avoid infinite loops caused by bad elf alignments
	  or name and description note sizes. Reported by
	  (Mikael Magnusson) <mmikael@comhem.se>

2004-03-09 13:55  Christos Zoulas  <christos@zoulas.com>

	* Fix possible memory leak on error and add missing regfree
	  (Dmitry V. Levin) <ldv@altlinux.org>

2003-12-23 12:12  Christos Zoulas  <christos@zoulas.com>

	* fix -k flag (Maciej W. Rozycki)

2003-11-18 14:10  Christos Zoulas  <christos@zoulas.com>

	* Try to give us much info as possible on corrupt elf files.
	  (Willy Tarreau) <willy@w.ods.org>
	* Updated python bindings (Brett Funderburg)
	   <brettf@deepfile.com>

2003-11-11 15:03  Christos Zoulas  <christos@zoulas.com>

	* Include file.h first, because it includes config.h
	  breaks largefile test macros otherwise.
	  (Paul Eggert <eggert@CS.UCLA.EDU> via
	   Lars Hecking <lhecking@nmrc.ie>)

2003-10-14 21:39  Christos Zoulas  <christos@zoulas.com>

	* Python bindings (Brett Funderburg) <brettf@deepfile.com>
	* Don't lookup past the end of the buffer
	  (Chad Hanson) <chanson@tcs-sec.com>
	* Add MAGIC_ERROR and api on magic_errno()

2003-10-08 12:40  Christos Zoulas  <christos@zoulas.com>

	* handle error conditions from compile as fatal
	  (Antti Kantee) <pooka@netbsd.org>
	* handle magic filename parsing sanely
	* more magic fixes.
	* fix a memory leak (Illes Marton) <illes.marton@balabit.hu>
	* describe magic file handling
	  (Bryan Henderson) <bryanh@giraffe-data.com>

2003-09-12 15:09  Christos Zoulas  <christos@zoulas.com>

	* update magic files.
	* remove largefile support from file.h; it breaks things on most OS's

2003-08-10 10:25  Christos Zoulas  <christos@zoulas.com>

	* fix unmapping'ing of mmaped files.

2003-07-10 12:03  Christos Zoulas  <christos@zoulas.com>

	* don't exit with -1 on error; always exit 1 (Marty Leisner)
	* restore utimes code.

2003-06-10 17:03  Christos Zoulas  <christos@zoulas.com>

	* make sure we don't access uninitialized memory.
	* pass lint
	* #ifdef __cplusplus in magic.h

2003-05-25 19:23  Christos Zoulas  <christos@zoulas.com>

	* rename cvs magic file to revision to deal with
	  case insensitive filesystems.

2003-05-23 17:03  Christos Zoulas  <christos@zoulas.com>

	* documentation fixes from Michael Piefel <piefel@debian.org>
	* magic fixes (various)
	* revert basename magic in .mgc name determination
	* buffer protection in uncompress,
	  signness issues,
	  close files
	  Maciej W. Rozycki <macro@ds2.pg.gda.pl

2003-04-21 20:12  Christos Zoulas  <christos@zoulas.com>

	* fix zsh magic

2003-04-04 16:59  Christos Zoulas  <christos@zoulas.com>

	* fix operand sort order in string.

2003-04-02 17:30  Christos Zoulas  <christos@zoulas.com>

	* cleanup namespace in magic.h

2003-04-02 13:50  Christos Zoulas  <christos@zoulas.com>

	* Magic additions (Alex Ott)
	* Fix bug that broke VPATH compilation (Peter Breitenlohner)

2003-03-28 16:03  Christos Zoulas  <christos@zoulas.com>

	* remove packed attribute from magic struct.
	* make the magic struct properly aligned.
	* bump version number of compiled files to 2.

2003-03-27 13:10  Christos Zoulas  <christos@zoulas.com>

	* separate tar detection and run it before softmagic.
	* fix reversed symlink test.
	* fix version printing.
	* make separator a string instead of a char.
	* update manual page and sort options.

2003-03-26 11:00  Christos Zoulas  <christos@zoulas.com>

	* Pass lint
	* make NULL in magic_file mean stdin
	* Fix "-" argument to file to pass NULL to magic_file
	* avoid pointer casts by using memcpy
	* rename magic_buf -> magic_buffer
	* keep only the first error
	* manual page: new sentence, new line
	* fix typo in api function (magic_buf -> magic_buffer)
